import 'package:jeweled/utils/tools.dart';

class DefaultGameSettings {
  static const List<String> availableParameters = [
    'boardSize',
    'colorsCount',
  ];

  static const int boardSizeValueSmall = 6;
  static const int boardSizeValueMedium = 10;
  static const int boardSizeValueLarge = 14;
  static const int boardSizeValueExtraLarge = 18;

  static const int defaultBoardSizeValue = boardSizeValueMedium;
  static const List<int> allowedBoardSizeValues = [
    boardSizeValueSmall,
    boardSizeValueMedium,
    boardSizeValueLarge,
    boardSizeValueExtraLarge,
  ];

  static const int colorsCountValueLow = 5;
  static const int colorsCountValueMedium = 6;
  static const int colorsCountValueHigh = 7;
  static const int colorsCountValueVeryHigh = 8;

  static const int defaultColorsCountValue = colorsCountValueMedium;
  static const List<int> allowedColorsCountValues = [
    colorsCountValueLow,
    colorsCountValueMedium,
    colorsCountValueHigh,
    colorsCountValueVeryHigh,
  ];

  static List<int> getAvailableValues(String parameterCode) {
    switch (parameterCode) {
      case 'boardSize':
        return DefaultGameSettings.allowedBoardSizeValues;
      case 'colorsCount':
        return DefaultGameSettings.allowedColorsCountValues;
    }

    printlog('Did not find any available value for game parameter "$parameterCode".');
    return [];
  }

  static int blockMinimumCellsCount = 3;
}
